#ifndef EHELP_H
#define EHELP_H

#include "estr.h"
#include "earray.h"

class ehelpExample
{
 public:
  estr syntax;
  estr summary;
  estr explanation;
};

class ehelpItem
{
 public:
  estr name;
  estr type;
  estr syntax;
  estr summary;
  estr description;
  earray<ehelpExample> examples;
};

class ehelp
{
 public:
  earray<ehelpItem> topics;

  ehelpItem& info(const estr& topic);
};

#endif

