#ifndef EUTILS_H
#define EUTILS_H


#ifndef _WIN32
 #include "eutils-config.h"

 #include <sys/types.h>
#else
 #ifndef WINVER                // Allow use of features specific to Windows 95 and Windows NT 4 or later.
  #define WINVER 0x0501        // Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
 #endif

 #ifndef _WIN32_WINNT        // Allow use of features specific to Windows NT 4 or later.
  #define _WIN32_WINNT 0x0501        // Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
 #endif                       

 #ifndef _WIN32_WINDOWS        // Allow use of features specific to Windows 98 or later.
  #define _WIN32_WINDOWS 0x0501 // Change this to the appropriate value to target Windows Me or later.
 #endif

 #include <winsock2.h>
 #include <windows.h>

 #include "eutils-win32-config.h"

  #ifdef _MSC_VER 
  //not #if defined(_WIN32) || defined(_WIN64) because we have strncasecmp in mingw
    #define strncasecmp _strnicmp
    #define strcasecmp _stricmp
    #define strcasestr StrStrIA
#endif

  #define __PRETTY_FUNCTION__ __FUNCSIG__
#endif

#endif

